using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace TheBitsMod
{
    public class TheBitsMod
    {
        public static void Main()
        {

          CategoryBuilder.Create("Bits", "Squares with diffirent colours", ModAPI.LoadSprite("Icons/CategoryIcon.png"));

            //Red Bit
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Red Bit",
                    NameToOrderByOverride = "Bit A",
                    DescriptionOverride = "A Plain Red Bit.",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/TheRedBit.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/TheRedBit2.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
					}
                }
            );

            //Orange Bit
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Orange Bit",
                    NameToOrderByOverride = "Bit B",
                    DescriptionOverride = "A Plain Orange Bit.",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/TheOrangeBit.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/TheOrangeBit2.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
					}
                }
            );

            //Yellow Bit
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Yellow Bit",
                    NameToOrderByOverride = "Bit C",
                    DescriptionOverride = "A Plain Yellow Bit.",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/TheYellowBit.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/TheYellowBit2.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
					}
                }
            );

            //Light Green Bit
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Light Green Bit",
                    NameToOrderByOverride = "Bit D",
                    DescriptionOverride = "A Plain Light Green Bit.",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/TheLightGreenBit.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/TheLightGreenBit2.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
					}
                }
            );

            //Green Bit
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Green Bit",
                    NameToOrderByOverride = "Bit E",
                    DescriptionOverride = "A Plain Green Bit.",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/TheGreenBit.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/TheGreenBit2.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
					}
                }
            );

            //Light Blue Bit
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Light Blue Bit",
                    NameToOrderByOverride = "Bit F",
                    DescriptionOverride = "A Plain Light Blue Bit.",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/TheLightBlueBit.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/TheLightBlueBit2.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
					}
                }
            );

            //Blue Bit
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Blue Bit",
                    NameToOrderByOverride = "Bit G",
                    DescriptionOverride = "A Plain Blue Bit.",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/TheBlueBit.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/TheBlueBit2.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
					}
                }
            );

            //Indigo Bit
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Indigo Bit",
                    NameToOrderByOverride = "Bit H",
                    DescriptionOverride = "A Plain Indigo Bit.",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/TheIndigoBit.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/TheIndigoBit2.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
					}
                }
            );

            //Pink Bit
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Pink Bit",
                    NameToOrderByOverride = "Bit I",
                    DescriptionOverride = "A Plain Pink Bit.",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/ThePinkBit.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/ThePinkBit2.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
					}
                }
            );

            //Violet Bit
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Violet Bit",
                    NameToOrderByOverride = "Bit J",
                    DescriptionOverride = "A Plain Violet Bit.",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/TheVioletBit.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/TheVioletBit2.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
					}
                }
            );

            //Purple Bit
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Purple Bit",
                    NameToOrderByOverride = "Bit K",
                    DescriptionOverride = "A Plain Purple Bit.",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/ThePurpleBit.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/ThePurpleBit2.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
					}
                }
            );

            //Brown Bit
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Brown Bit",
                    NameToOrderByOverride = "Bit L",
                    DescriptionOverride = "A Plain Brown Bit.",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/TheBrownBit.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/TheBrownBit2.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
					}
                }
            );

            //Dark Brown Bit
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Dark Brown Bit",
                    NameToOrderByOverride = "Bit M",
                    DescriptionOverride = "A Plain Dark Brown Bit.",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/TheDarkBrownBit.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/TheDarkBrownBit2.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
					}
                }
            );

            //White Bit
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "White Bit",
                    NameToOrderByOverride = "Bit N",
                    DescriptionOverride = "A Plain White Bit.",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/TheWhiteBit.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/TheWhiteBit2.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
					}
                }
            );

            //Light Gray Bit
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Light Gray Bit",
                    NameToOrderByOverride = "Bit O",
                    DescriptionOverride = "A Plain Light Gray Bit.",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/TheLightGrayBit.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/TheLightGrayBit2.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
					}
                }
            );

            //Gray Bit
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Gray Bit",
                    NameToOrderByOverride = "Bit P",
                    DescriptionOverride = "A Plain Gray Bit.",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/TheGrayBit.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/TheGrayBit2.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
					}
                }
            );

            //Black Bit
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Black Bit",
                    NameToOrderByOverride = "Bit Q",
                    DescriptionOverride = "A Plain Black Bit.",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/TheBlackBit.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/TheBlackBit2.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
					}
                }
            );

            //The Red Glowing Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "The Red Glowing Bit",
                    DescriptionOverride = "A Red Glowing Bit",
                    NameToOrderByOverride = "Bit R",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/RedGlowingBitIcon.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/GlowingBitRed.png"),
                           ModAPI.LoadSprite("Sprites/BrightGlowingBitRed.png"),
                           ModAPI.LoadSprite("Sprites/TheRedBit2.png"),
                        };

                        var light = ModAPI.CreateLight(Instance.transform, new Color(1f, 0f, 0.03921f, 1f), 7.5f, 3f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);
                        Instance.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //The Orange Glowing Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "The Orange Glowing Bit",
                    DescriptionOverride = "A Orange Glowing Bit",
                    NameToOrderByOverride = "Bit S",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/OrangeGlowingBitIcon.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/GlowingBitOrange.png"),
                           ModAPI.LoadSprite("Sprites/BrightGlowingBitOrange.png"),
                           ModAPI.LoadSprite("Sprites/TheOrangeBit2.png"),
                        };

                        var light = ModAPI.CreateLight(Instance.transform, new Color(0.89803f, 0.44705f, 0f, 1f), 7.5f, 3f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);
                        Instance.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //The Yellow Glowing Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "The Yellow Glowing Bit",
                    DescriptionOverride = "A Yellow Glowing Bit",
                    NameToOrderByOverride = "Bit T",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/YellowGlowingBitIcon.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/GlowingBitYellow.png"),
                           ModAPI.LoadSprite("Sprites/BrightGlowingBitYellow.png"),
                           ModAPI.LoadSprite("Sprites/TheYellowBit2.png"),
                        };

                        var light = ModAPI.CreateLight(Instance.transform, new Color(1f, 0.92156f, 0.34117f, 1f), 7.5f, 3f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);
                        Instance.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //The Green Glowing Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "The Green Glowing Bit",
                    DescriptionOverride = "A Green Glowing Bit",
                    NameToOrderByOverride = "Bit U",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/GreenGlowingBitIcon.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/GlowingBitGreen.png"),
                           ModAPI.LoadSprite("Sprites/BrightGlowingBitGreen.png"),
                           ModAPI.LoadSprite("Sprites/TheLightGreenBit2.png"),
                        };

                        var light = ModAPI.CreateLight(Instance.transform, new Color(0.60000f, 0.90196f, 0.37254f, 1f), 7.5f, 3f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);
                        Instance.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //The Dark Green Glowing Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "The Dark Green Glowing Bit",
                    DescriptionOverride = "A Dark Green Glowing Bit",
                    NameToOrderByOverride = "Bit V",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/DarkGreenGlowingBitIcon.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/GlowingBitDarkGreen.png"),
                           ModAPI.LoadSprite("Sprites/BrightGlowingBitDarkGreen.png"),
                           ModAPI.LoadSprite("Sprites/TheGreenBit2.png"),
                        };

                        var light = ModAPI.CreateLight(Instance.transform, new Color(0f, 0.45098f, 0.015686f, 1f), 7.5f, 3f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);
                        Instance.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //The Blue Glowing Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "The Blue Glowing Bit",
                    DescriptionOverride = "A Blue Glowing Bit",
                    NameToOrderByOverride = "Bit W",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/BlueGlowingBitIcon.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/GlowingBitBlue.png"),
                           ModAPI.LoadSprite("Sprites/BrightGlowingBitBlue.png"),
                           ModAPI.LoadSprite("Sprites/TheBlueBit2.png"),
                        };

                        var light = ModAPI.CreateLight(Instance.transform, new Color(0f, 0.41176f, 0.66666f, 1f), 7.5f, 3f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);
                        Instance.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //The Dark Blue Glowing Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "The Dark Blue Glowing Bit",
                    DescriptionOverride = "A Dark Blue Glowing Bit",
                    NameToOrderByOverride = "Bit X",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/DarkBlueGlowingBitIcon.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/GlowingBitDarkBlue.png"),
                           ModAPI.LoadSprite("Sprites/BrightGlowingBitDarkBlue.png"),
                           ModAPI.LoadSprite("Sprites/TheIndigoBit2.png"),
                        };

                        var light = ModAPI.CreateLight(Instance.transform, new Color(0.24705f, 0.28235f, 0.800000f, 1f), 7.5f, 3f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);
                        Instance.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //The Purple Glowing Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "The Purple Glowing Bit",
                    DescriptionOverride = "A Purple Glowing Bit",
                    NameToOrderByOverride = "Bit Y",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/PurpleGlowingBitIcon.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/GlowingBitPurple.png"),
                           ModAPI.LoadSprite("Sprites/BrightGlowingBitPurple.png"),
                           ModAPI.LoadSprite("Sprites/ThePurpleBit2.png"),
                        };

                        var light = ModAPI.CreateLight(Instance.transform, new Color(0.47843f, 0.03529f, 0.98039f, 1f), 7.5f, 3f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);
                        Instance.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //The Violet Glowing Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "The Violet Glowing Bit",
                    DescriptionOverride = "A Violet Glowing Bit",
                    NameToOrderByOverride = "Bit Z",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/VioletGlowingBitIcon.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/GlowingBitViolet.png"),
                           ModAPI.LoadSprite("Sprites/BrightGlowingBitViolet.png"),
                           ModAPI.LoadSprite("Sprites/TheVioletBit2.png"),
                        };

                        var light = ModAPI.CreateLight(Instance.transform, new Color(0.56862f, 0.09803f, 0.74509f, 1f), 7.5f, 3f);
                        
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);
                        Instance.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //The Pink Glowing Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "The Pink Glowing Bit",
                    DescriptionOverride = "A Pink Glowing Bit",
                    NameToOrderByOverride = "Bit Z A",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/PinkGlowingBitIcon.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/GlowingBitPink.png"),
                           ModAPI.LoadSprite("Sprites/BrightGlowingBitPink.png"),
                           ModAPI.LoadSprite("Sprites/ThePinkBit2.png"),
                        };

                        var light = ModAPI.CreateLight(Instance.transform, new Color(1f, 0.52941f, 0.62745f, 1f), 7.5f, 3f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);
                        Instance.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );
            
            //The White Glowing Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "The White Glowing Bit",
                    DescriptionOverride = "A White Glowing Bit",
                    NameToOrderByOverride = "Bit Z B",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/WhiteGlowingBitIcon.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/GlowingBitWhite.png"),
                           ModAPI.LoadSprite("Sprites/BrightGlowingBitWhite.png"),
                           ModAPI.LoadSprite("Sprites/TheWhiteBit2.png"),
                        };

                        var light = ModAPI.CreateLight(Instance.transform, Color.white, 7.5f, 3f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);
                        Instance.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //The Glowing Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "The Glowing Bit",
                    DescriptionOverride = "I kept it in the mod so contraptions don't break",
                    NameToOrderByOverride = "Bit",
                    CategoryOverride = ModAPI.FindCategory("None"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/RedGlowingBitIcon.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/GlowingBitRed.png"),
                           ModAPI.LoadSprite("Sprites/GlowingBitOrange.png"),
                           ModAPI.LoadSprite("Sprites/GlowingBitYellow.png"),
                           ModAPI.LoadSprite("Sprites/GlowingBitGreen.png"),
                           ModAPI.LoadSprite("Sprites/GlowingBitDarkGreen.png"),
                           ModAPI.LoadSprite("Sprites/GlowingBitBlue.png"),
                           ModAPI.LoadSprite("Sprites/GlowingBitDarkBlue.png"),
                           ModAPI.LoadSprite("Sprites/GlowingBitPurple.png"),
                           ModAPI.LoadSprite("Sprites/GlowingBitViolet.png"),
                           ModAPI.LoadSprite("Sprites/GlowingBitPink.png"),
                           ModAPI.LoadSprite("Sprites/GlowingBitWhite.png"),
                        };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);
                        Instance.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //The Bright Glowing Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "The Bright Glowing Bit",
                    DescriptionOverride = "I kept it in the mod so contraptions don't break",
                    NameToOrderByOverride = "Bit",
                    CategoryOverride = ModAPI.FindCategory("None"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/RedGlowingBitIcon.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/BrightGlowingBitRed.png"),
                           ModAPI.LoadSprite("Sprites/BrightGlowingBitOrange.png"),
                           ModAPI.LoadSprite("Sprites/BrightGlowingBitYellow.png"),
                           ModAPI.LoadSprite("Sprites/BrightGlowingBitGreen.png"),
                           ModAPI.LoadSprite("Sprites/BrightGlowingBitDarkGreen.png"),
                           ModAPI.LoadSprite("Sprites/BrightGlowingBitBlue.png"),
                           ModAPI.LoadSprite("Sprites/BrightGlowingBitDarkBlue.png"),
                           ModAPI.LoadSprite("Sprites/BrightGlowingBitPurple.png"),
                           ModAPI.LoadSprite("Sprites/BrightGlowingBitViolet.png"),
                           ModAPI.LoadSprite("Sprites/BrightGlowingBitPink.png"),
                           ModAPI.LoadSprite("Sprites/BrightGlowingBitWhite.png"),
                        };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);
                        Instance.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //Blaster Impact Special Effects Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "Blaster Impact Special Effects Bit",
                    DescriptionOverride = "A Bit that creates the Blaster Impact particle once activated",
                    NameToOrderByOverride = "Bit Z C",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/ParticleIcon1.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/TheWhiteBit2.png"),
                           ModAPI.LoadSprite("Sprites/TheEmptyBit2.png"),
                        };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;

                        Instance.AddComponent<UseEventTrigger>().Action = () => 
                        {
                        ModAPI.CreateParticleEffect("BlasterImpact", Instance.transform.position);
                        };

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //Fuse Blown Special Effects Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "Fuse Blown Special Effects Bit",
                    DescriptionOverride = "A Bit that creates the Fuse Blown particle once activated",
                    NameToOrderByOverride = "Bit Z D",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/ParticleIcon2.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/TheWhiteBit2.png"),
                           ModAPI.LoadSprite("Sprites/TheEmptyBit2.png"),
                        };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;

                        Instance.AddComponent<UseEventTrigger>().Action = () => 
                        {
                        ModAPI.CreateParticleEffect("FuseBlown", Instance.transform.position);
                        };

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //Metal Hit Special Effects Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "Metal Hit Special Effects Bit",
                    DescriptionOverride = "A Bit that creates the Metal Hit particle once activated",
                    NameToOrderByOverride = "Bit Z F",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/ParticleIcon3.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/TheWhiteBit2.png"),
                           ModAPI.LoadSprite("Sprites/TheEmptyBit2.png"),
                        };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;

                        Instance.AddComponent<UseEventTrigger>().Action = () => 
                        {
                        ModAPI.CreateParticleEffect("MetalHit", Instance.transform.position);
                        };

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //Disintegration Special Effects Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "Disintegration Special Effects Bit",
                    DescriptionOverride = "A Bit that creates the Disintegration particle once activated.",
                    NameToOrderByOverride = "Bit Z G",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/ParticleIcon4.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/TheWhiteBit2.png"),
                           ModAPI.LoadSprite("Sprites/TheEmptyBit2.png"),
                        };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;

                        Instance.AddComponent<UseEventTrigger>().Action = () => 
                        {
                        ModAPI.CreateParticleEffect("Disintegration", Instance.transform.position);
                        };

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //Blaster Impact Hole Special Effects Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "Blaster Impact Hole Special Effects Bit",
                    DescriptionOverride = "A Bit that creates the Blaster Impact Hole particle once activated.",
                    NameToOrderByOverride = "Bit Z H",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/ParticleIcon5.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/TheWhiteBit2.png"),
                           ModAPI.LoadSprite("Sprites/TheEmptyBit2.png"),
                        };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;

                        Instance.AddComponent<UseEventTrigger>().Action = () => 
                        {
                        ModAPI.CreateParticleEffect("BlasterImpactHole", Instance.transform.position);
                        };

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //Spark Special Effects Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "Spark Special Effects Bit",
                    DescriptionOverride = "A Bit that creates the Spark particle once activated.",
                    NameToOrderByOverride = "Bit Z I",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/ParticleIcon6.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/TheWhiteBit2.png"),
                           ModAPI.LoadSprite("Sprites/TheEmptyBit2.png"),
                        };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;

                        Instance.AddComponent<UseEventTrigger>().Action = () => 
                        {
                        ModAPI.CreateParticleEffect("Spark", Instance.transform.position);
                        };

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //Wood Hit Special Effects Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "Wood Hit Special Effects Bit",
                    DescriptionOverride = "A Bit that creates the Wood Hit particle once activated.",
                    NameToOrderByOverride = "Bit Z J",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/ParticleIcon7.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/TheWhiteBit2.png"),
                           ModAPI.LoadSprite("Sprites/TheEmptyBit2.png"),
                        };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;

                        Instance.AddComponent<UseEventTrigger>().Action = () => 
                        {
                        ModAPI.CreateParticleEffect("WoodHit", Instance.transform.position);
                        };

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //Pink Explosion Special Effects Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "Pink Explosion Special Effects Bit",
                    DescriptionOverride = "A Bit that creates the Pink Explosion particle once activated.",
                    NameToOrderByOverride = "Bit Z K",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/ParticleIcon8.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/TheWhiteBit2.png"),
                           ModAPI.LoadSprite("Sprites/TheEmptyBit2.png"),
                        };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;

                        Instance.AddComponent<UseEventTrigger>().Action = () => 
                        {
                        ModAPI.CreateParticleEffect("PinkExplosion", Instance.transform.position);
                        };

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //Enormous Explosion Special Effects Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "Enormous Explosion Special Effects Bit",
                    DescriptionOverride = "A Bit that creates the Enormous Explosion particle once activated.",
                    NameToOrderByOverride = "Bit Z L",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/ParticleIcon9.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/TheWhiteBit2.png"),
                           ModAPI.LoadSprite("Sprites/TheEmptyBit2.png"),
                        };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;

                        Instance.AddComponent<UseEventTrigger>().Action = () => 
                        {
                        ModAPI.CreateParticleEffect("EnormousExplosion", Instance.transform.position);
                        };

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //Blood Explosion Special Effects Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "Blood Explosion Special Effects Bit",
                    DescriptionOverride = "A Bit that creates the Blood Explosion particle once activated.",
                    NameToOrderByOverride = "Bit Z M",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/ParticleIcon14.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/TheWhiteBit2.png"),
                           ModAPI.LoadSprite("Sprites/TheEmptyBit2.png"),
                        };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;

                        Instance.AddComponent<UseEventTrigger>().Action = () => 
                        {
                        ModAPI.CreateParticleEffect("BloodExplosion", Instance.transform.position);
                        };

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //Big Explosion Special Effects Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "Big Explosion Special Effects Bit",
                    DescriptionOverride = "A Bit that creates the Big Explosion particle once activated.",
                    NameToOrderByOverride = "Bit Z N",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/ParticleIcon10.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/TheWhiteBit2.png"),
                           ModAPI.LoadSprite("Sprites/TheEmptyBit2.png"),
                        };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;

                        Instance.AddComponent<UseEventTrigger>().Action = () => 
                        {
                        ModAPI.CreateParticleEffect("BigExplosion", Instance.transform.position);
                        };

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //Explosion Special Effects Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "Explosion Special Effects Bit",
                    DescriptionOverride = "A Bit that creates the Explosion particle once activated.",
                    NameToOrderByOverride = "Bit Z O",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/ParticleIcon11.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/TheWhiteBit2.png"),
                           ModAPI.LoadSprite("Sprites/TheEmptyBit2.png"),
                        };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;

                        Instance.AddComponent<UseEventTrigger>().Action = () => 
                        {
                        ModAPI.CreateParticleEffect("Explosion", Instance.transform.position);
                        };

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //Red Barrel Explosion Special Effects Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "Red Barrel Explosion Special Effects Bit",
                    DescriptionOverride = "A Bit that creates the Red Barrel Explosion particle once activated.",
                    NameToOrderByOverride = "Bit Z P",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/ParticleIcon12.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/TheWhiteBit2.png"),
                           ModAPI.LoadSprite("Sprites/TheEmptyBit2.png"),
                        };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;

                        Instance.AddComponent<UseEventTrigger>().Action = () => 
                        {
                        ModAPI.CreateParticleEffect("RedBarrelExplosion", Instance.transform.position);
                        };

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //Ion Explosion Special Effects Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "Ion Explosion Special Effects Bit",
                    DescriptionOverride = "A Bit that creates the Ion Explosion particle once activated.",
                    NameToOrderByOverride = "Bit Z Q",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/ParticleIcon13.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/TheWhiteBit2.png"),
                           ModAPI.LoadSprite("Sprites/TheEmptyBit2.png"),
                        };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;

                        Instance.AddComponent<UseEventTrigger>().Action = () => 
                        {
                        ModAPI.CreateParticleEffect("IonExplosion", Instance.transform.position);
                        };

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //Big Zap Special Effects Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "Big Zap Special Effects Bit",
                    DescriptionOverride = "A Bit that creates the Big Zap particle once activated.",
                    NameToOrderByOverride = "Bit Z R",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/ParticleIcon15.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/TheWhiteBit2.png"),
                           ModAPI.LoadSprite("Sprites/TheEmptyBit2.png"),
                        };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;

                        Instance.AddComponent<UseEventTrigger>().Action = () => 
                        {
                        ModAPI.CreateParticleEffect("BigZap", Instance.transform.position);
                        };

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //Huge Zap Special Effects Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "Huge Zap Special Effects Bit",
                    DescriptionOverride = "A Bit that creates the Huge Zap particle once activated.",
                    NameToOrderByOverride = "Bit Z S",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/ParticleIcon16.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/TheWhiteBit2.png"),
                           ModAPI.LoadSprite("Sprites/TheEmptyBit2.png"),
                        };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;

                        Instance.AddComponent<UseEventTrigger>().Action = () => 
                        {
                        ModAPI.CreateParticleEffect("HugeZap", Instance.transform.position);
                        };

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //Ricochet Special Effects Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "Ricochet Special Effects Bit",
                    DescriptionOverride = "A Bit that creates the Ricochet particle once activated.",
                    NameToOrderByOverride = "Bit Z T",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/ParticleIcon17.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/TheWhiteBit2.png"),
                           ModAPI.LoadSprite("Sprites/TheEmptyBit2.png"),
                        };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;

                        Instance.AddComponent<UseEventTrigger>().Action = () => 
                        {
                        ModAPI.CreateParticleEffect("Ricochet", Instance.transform.position);
                        };

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //Broken Electronics Spark Special Effects Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "Broken Electronics Spark Special Effects Bit",
                    DescriptionOverride = "A Bit that creates the Broken Electronics Spark particle once activated.",
                    NameToOrderByOverride = "Bit Z U",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/ParticleIcon18.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/TheWhiteBit2.png"),
                           ModAPI.LoadSprite("Sprites/TheEmptyBit2.png"),
                        };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;

                        Instance.AddComponent<UseEventTrigger>().Action = () => 
                        {
                        ModAPI.CreateParticleEffect("BrokenElectronicsSpark", Instance.transform.position);
                        };

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //Flash Special Effects Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "Flash Special Effects Bit",
                    DescriptionOverride = "A Bit that creates the Flash particle once activated.",
                    NameToOrderByOverride = "Bit Z V",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/ParticleIcon19.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/TheWhiteBit2.png"),
                           ModAPI.LoadSprite("Sprites/TheEmptyBit2.png"),
                        };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;

                        Instance.AddComponent<UseEventTrigger>().Action = () => 
                        {
                        ModAPI.CreateParticleEffect("Flash", Instance.transform.position);
                        };

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );

            //Vapor Special Effects Bit
            ModAPI.Register(
               new Modification()
               {

                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
                    NameOverride = "Vapor Special Effects Bit",
                    DescriptionOverride = "A Bit that creates the Vapor particle once activated.",
                    NameToOrderByOverride = "Bit Z W",
                    CategoryOverride = ModAPI.FindCategory("Bits"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/ParticleIcon20.png", 5f),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                           ModAPI.LoadSprite("Sprites/TheWhiteBit2.png"),
                           ModAPI.LoadSprite("Sprites/TheEmptyBit2.png"),
                        };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(c);
                        }

                        Instance.AddComponent<UseEventTrigger>().Action = () => 
                        {
                        ModAPI.CreateParticleEffect("Vapor", Instance.transform.position);
                        };

                        Instance.AddComponent<BoxCollider2D>().size = new Vector2(0.2285714f, 0.2285714f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.25f;
                    }
                }
            );
        }
    }
}